import { __awaiter } from "tslib";
import { generateAuthenticationOptions, generateRegistrationOptions, verifyAuthenticationResponse, verifyRegistrationResponse } from "@simplewebauthn/server";
import { getAuth } from "firebase-admin/auth";
import { FieldValue, getFirestore, Timestamp } from "firebase-admin/firestore";
import { runWith } from "firebase-functions";
export const getFirebaseWebAuthn = (firebaseWebAuthnConfig) => runWith({
    enforceAppCheck: true,
})
    .https
    .onCall((functionRequest, callableContext) => __awaiter(void 0, void 0, void 0, function* () {
    return callableContext.auth ? ((auth, firestore) => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        return functionRequest.operation === "clear challenge" ? firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => __awaiter(void 0, void 0, void 0, function* () {
            var _j, _k;
            return userDocument ? userDocument.challenge ? userDocument.credential ? firestore.collection("webAuthnUsers").doc(((_j = callableContext.auth) === null || _j === void 0 ? void 0 : _j.uid) || "").update({
                challenge: FieldValue.delete(),
            }).then(() => ({
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : firestore.collection("webAuthnUsers").doc(((_k = callableContext.auth) === null || _k === void 0 ? void 0 : _k.uid) || "").delete().then(() => ({
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            } : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "clear user doc" ? firestore.collection("webAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => __awaiter(void 0, void 0, void 0, function* () {
            var _l;
            return userDocument ? firestore.collection("webAuthnUsers").doc(((_l = callableContext.auth) === null || _l === void 0 ? void 0 : _l.uid) || "").delete().then(() => ({
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "create authentication challenge" ? ((publicKeyCredentialRequestOptionsJSON) => {
            var _a;
            return firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").set({
                challenge: publicKeyCredentialRequestOptionsJSON.challenge,
            }, {
                merge: true,
            }).then(() => ({
                requestOptions: publicKeyCredentialRequestOptionsJSON,
                operation: functionRequest.operation,
                success: true,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            }));
        })(generateAuthenticationOptions({
            rpID: callableContext.rawRequest.hostname,
            userVerification: firebaseWebAuthnConfig.userVerificationRequirement,
        })) : functionRequest.operation === "create reauthentication challenge" ? firestore.collection("webAuthnUsers").doc(((_c = callableContext.auth) === null || _c === void 0 ? void 0 : _c.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => __awaiter(void 0, void 0, void 0, function* () {
            return userDocument ? userDocument.credential ? ((publicKeyCredentialRequestOptions) => {
                var _a;
                return firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").set({
                    challenge: publicKeyCredentialRequestOptions.challenge,
                }, {
                    merge: true,
                }).then(() => ({
                    requestOptions: publicKeyCredentialRequestOptions,
                    operation: functionRequest.operation,
                    success: true,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            })(generateAuthenticationOptions({
                allowCredentials: [
                    {
                        id: userDocument.credential.id,
                        type: "public-key",
                    },
                ],
                rpID: callableContext.rawRequest.hostname,
                userVerification: firebaseWebAuthnConfig.userVerificationRequirement,
            })) : {
                code: "user-doc-missing-passkey-fields",
                message: "User doc is missing passkey fields from prior operation.",
                operation: functionRequest.operation,
                success: false,
            } : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "create registration challenge" ? firestore.collection("webAuthnUsers").doc(((_d = callableContext.auth) === null || _d === void 0 ? void 0 : _d.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => __awaiter(void 0, void 0, void 0, function* () {
            var _m;
            return !(userDocument === null || userDocument === void 0 ? void 0 : userDocument.credential) ? ((publicKeyCredentialCreationOptions) => {
                var _a;
                return firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").set({
                    challenge: publicKeyCredentialCreationOptions.challenge,
                }).then(() => ({
                    creationOptions: publicKeyCredentialCreationOptions,
                    operation: functionRequest.operation,
                    success: true,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            })(generateRegistrationOptions({
                authenticatorSelection: {
                    authenticatorAttachment: firebaseWebAuthnConfig.authenticatorAttachment,
                    residentKey: "required",
                    userVerification: firebaseWebAuthnConfig.userVerificationRequirement,
                },
                rpID: callableContext.rawRequest.hostname,
                rpName: firebaseWebAuthnConfig.relyingPartyName,
                userID: ((_m = callableContext.auth) === null || _m === void 0 ? void 0 : _m.uid) || "",
                userName: functionRequest.name,
            })) : {
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "verify authentication" ? functionRequest.authenticationResponse.response.userHandle !== ((_e = callableContext.auth) === null || _e === void 0 ? void 0 : _e.uid) ? firestore.collection("webAuthnUsers").doc(functionRequest.authenticationResponse.response.userHandle || "").get().then((userDocumentSnapshot) => ((userDocument) => {
            var _a, _b, _c;
            return userDocument ? userDocument.credential ? firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").get().then((priorUserDocumentSnapshot) => ((priorUserDocument) => {
                var _a, _b, _c, _d;
                return priorUserDocument && priorUserDocument.challenge ? verifyAuthenticationResponse({
                    authenticator: {
                        counter: (_a = userDocument.credential) === null || _a === void 0 ? void 0 : _a.counter,
                        credentialID: (_b = userDocument.credential) === null || _b === void 0 ? void 0 : _b.id,
                        credentialPublicKey: (_c = userDocument.credential) === null || _c === void 0 ? void 0 : _c.publicKey,
                    },
                    expectedChallenge: priorUserDocument.challenge,
                    expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                    expectedRPID: callableContext.rawRequest.hostname,
                    requireUserVerification: true,
                    response: functionRequest.authenticationResponse,
                }).then((verifiedAuthenticationResponse) => {
                    var _a, _b, _c, _d;
                    return verifiedAuthenticationResponse.verified ? firestore.collection("webAuthnUsers").doc(functionRequest.authenticationResponse.response.userHandle || "").update({
                        challenge: FieldValue.delete(),
                        credential: Object.assign(Object.assign({}, userDocument["credential"]), { backedUp: (_a = verifiedAuthenticationResponse.authenticationInfo) === null || _a === void 0 ? void 0 : _a.credentialBackedUp, deviceType: (_b = verifiedAuthenticationResponse.authenticationInfo) === null || _b === void 0 ? void 0 : _b.credentialDeviceType }),
                        lastPresent: Timestamp.fromDate(new Date()),
                        lastVerified: ((_c = verifiedAuthenticationResponse.authenticationInfo) === null || _c === void 0 ? void 0 : _c.userVerified) ? Timestamp.fromDate(new Date()) : userDocument["lastVerified"] || FieldValue.delete(),
                    }).then(() => {
                        var _a, _b;
                        return priorUserDocument.credential ? firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").update({
                            challenge: FieldValue.delete(),
                        }).then(() => auth.createCustomToken(functionRequest.authenticationResponse.response.userHandle || "").then((customToken) => ({
                            customToken: customToken,
                            operation: functionRequest.operation,
                            success: true,
                        })).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }))).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        })) : firestore.collection("webAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").delete().then(() => auth.createCustomToken(functionRequest.authenticationResponse.response.userHandle || "").then((customToken) => ({
                            customToken: customToken,
                            operation: functionRequest.operation,
                            success: true,
                        })).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }))).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }));
                    }).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    })) : firestore.collection("webAuthnUsers").doc(((_d = callableContext.auth) === null || _d === void 0 ? void 0 : _d.uid) || "").delete().then(() => ({
                        code: "not-verified",
                        message: "User not verified.",
                        operation: functionRequest.operation,
                        success: false,
                    })).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    }));
                }) : firestore.collection("webAuthnUsers").doc(((_d = callableContext.auth) === null || _d === void 0 ? void 0 : _d.uid) || "").delete().then(() => ({
                    code: "user-doc-missing-challenge-field",
                    message: "User doc is missing challenge field from prior operation.",
                    operation: functionRequest.operation,
                    success: false,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            })(priorUserDocumentSnapshot.data())) : firestore.collection("webAuthnUsers").doc(((_b = callableContext.auth) === null || _b === void 0 ? void 0 : _b.uid) || "").delete().then(() => ({
                code: "user-doc-missing-passkey-fields",
                message: "User doc is missing passkey fields from prior operation.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : firestore.collection("webAuthnUsers").doc(((_c = callableContext.auth) === null || _c === void 0 ? void 0 : _c.uid) || "").delete().then(() => ({
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            }));
        })(userDocumentSnapshot.data())) : firestore.collection("webAuthnUsers").doc(((_f = callableContext.auth) === null || _f === void 0 ? void 0 : _f.uid) || "").update({
            challenge: FieldValue.delete(),
        }).then(() => ({
            code: "no-op",
            message: "No operation is needed.",
            operation: functionRequest.operation,
            success: false,
        })).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : functionRequest.operation === "verify reauthentication" ? firestore.collection("webAuthnUsers").doc(((_g = callableContext.auth) === null || _g === void 0 ? void 0 : _g.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => __awaiter(void 0, void 0, void 0, function* () {
            var _o;
            return userDocument ? userDocument.credential ? (() => __awaiter(void 0, void 0, void 0, function* () {
                var _p, _q, _r;
                return userDocument.challenge ? verifyAuthenticationResponse({
                    authenticator: {
                        counter: (_p = userDocument.credential) === null || _p === void 0 ? void 0 : _p.counter,
                        credentialID: (_q = userDocument.credential) === null || _q === void 0 ? void 0 : _q.id,
                        credentialPublicKey: (_r = userDocument.credential) === null || _r === void 0 ? void 0 : _r.publicKey,
                    },
                    expectedChallenge: userDocument.challenge,
                    expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                    expectedRPID: callableContext.rawRequest.hostname,
                    requireUserVerification: true,
                    response: functionRequest.authenticationResponse,
                }).then((verifiedAuthenticationResponse) => {
                    var _a, _b, _c, _d, _e;
                    return verifiedAuthenticationResponse.verified ? firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").update({
                        challenge: FieldValue.delete(),
                        credential: Object.assign(Object.assign({}, userDocument["credential"]), { backedUp: (_b = verifiedAuthenticationResponse.authenticationInfo) === null || _b === void 0 ? void 0 : _b.credentialBackedUp, deviceType: (_c = verifiedAuthenticationResponse.authenticationInfo) === null || _c === void 0 ? void 0 : _c.credentialDeviceType }),
                        lastPresent: Timestamp.fromDate(new Date()),
                        lastVerified: ((_d = verifiedAuthenticationResponse.authenticationInfo) === null || _d === void 0 ? void 0 : _d.userVerified) ? Timestamp.fromDate(new Date()) : userDocument["lastVerified"] || FieldValue.delete(),
                    }).then(() => {
                        var _a;
                        return auth.createCustomToken(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").then((customToken) => ({
                            customToken: customToken,
                            operation: functionRequest.operation,
                            success: true,
                        })).catch((firebaseError) => ({
                            code: firebaseError.code,
                            message: firebaseError.message,
                            operation: functionRequest.operation,
                            success: false,
                        }));
                    }).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    })) : firestore.collection("webAuthnUsers").doc(((_e = callableContext.auth) === null || _e === void 0 ? void 0 : _e.uid) || "").update({
                        challenge: FieldValue.delete(),
                    }).then(() => ({
                        code: "not-verified",
                        message: "User not verified.",
                        operation: functionRequest.operation,
                        success: false,
                    })).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    }));
                }) : {
                    code: "user-doc-missing-challenge-field",
                    message: "User doc is missing challenge field from prior operation.",
                    operation: functionRequest.operation,
                    success: false,
                };
            }))() : firestore.collection("webAuthnUsers").doc(((_o = callableContext.auth) === null || _o === void 0 ? void 0 : _o.uid) || "").delete().then(() => ({
                code: "user-doc-missing-passkey-fields",
                message: "User doc is missing passkey fields from prior operation.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())) : functionRequest.operation === "verify registration" ? firestore.collection("webAuthnUsers").doc(((_h = callableContext.auth) === null || _h === void 0 ? void 0 : _h.uid) || "").get().then((userDocumentSnapshot) => ((userDocument) => __awaiter(void 0, void 0, void 0, function* () {
            var _s, _t;
            return userDocument ? userDocument.challenge ? !userDocument.credential ? verifyRegistrationResponse({
                expectedChallenge: userDocument["challenge"],
                expectedOrigin: "https://" + callableContext.rawRequest.hostname,
                expectedRPID: callableContext.rawRequest.hostname,
                requireUserVerification: true,
                response: functionRequest.registrationResponse,
            }).then((verifiedRegistrationResponse) => {
                var _a, _b, _c, _d, _e, _f, _g, _h;
                return verifiedRegistrationResponse.verified ? firestore.collection("webAuthnUsers").doc(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").update({
                    challenge: FieldValue.delete(),
                    credential: {
                        backedUp: (_b = verifiedRegistrationResponse.registrationInfo) === null || _b === void 0 ? void 0 : _b.credentialBackedUp,
                        counter: (_c = verifiedRegistrationResponse.registrationInfo) === null || _c === void 0 ? void 0 : _c.counter,
                        deviceType: (_d = verifiedRegistrationResponse.registrationInfo) === null || _d === void 0 ? void 0 : _d.credentialDeviceType,
                        id: (_e = verifiedRegistrationResponse.registrationInfo) === null || _e === void 0 ? void 0 : _e.credentialID,
                        publicKey: (_f = verifiedRegistrationResponse.registrationInfo) === null || _f === void 0 ? void 0 : _f.credentialPublicKey
                    },
                    lastPresent: Timestamp.fromDate(new Date()),
                    lastVerified: ((_g = verifiedRegistrationResponse.registrationInfo) === null || _g === void 0 ? void 0 : _g.userVerified) ? Timestamp.fromDate(new Date()) : userDocument["lastVerified"] || FieldValue.delete(),
                }).then(() => {
                    var _a;
                    return auth.createCustomToken(((_a = callableContext.auth) === null || _a === void 0 ? void 0 : _a.uid) || "").then((customToken) => ({
                        customToken: customToken,
                        operation: functionRequest.operation,
                        success: true,
                    })).catch((firebaseError) => ({
                        code: firebaseError.code,
                        message: firebaseError.message,
                        operation: functionRequest.operation,
                        success: false,
                    }));
                }).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                })) : firestore.collection("webAuthnUsers").doc(((_h = callableContext.auth) === null || _h === void 0 ? void 0 : _h.uid) || "").delete().then(() => ({
                    code: "not-verified",
                    message: "User not verified.",
                    operation: functionRequest.operation,
                    success: false,
                })).catch((firebaseError) => ({
                    code: firebaseError.code,
                    message: firebaseError.message,
                    operation: functionRequest.operation,
                    success: false,
                }));
            }) : firestore.collection("webAuthnUsers").doc(((_s = callableContext.auth) === null || _s === void 0 ? void 0 : _s.uid) || "").update({
                challenge: FieldValue.delete(),
            }).then(() => ({
                code: "no-op",
                message: "No operation is needed.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : firestore.collection("webAuthnUsers").doc(((_t = callableContext.auth) === null || _t === void 0 ? void 0 : _t.uid) || "").delete().then(() => ({
                code: "user-doc-missing-challenge-field",
                message: "User doc is missing challenge field from prior operation.",
                operation: functionRequest.operation,
                success: false,
            })).catch((firebaseError) => ({
                code: firebaseError.code,
                message: firebaseError.message,
                operation: functionRequest.operation,
                success: false,
            })) : {
                code: "missing-user-doc",
                message: "No user document was found in Firestore.",
                operation: functionRequest.operation,
                success: false,
            };
        }))(userDocumentSnapshot.data())).catch((firebaseError) => ({
            code: firebaseError.code,
            message: firebaseError.message,
            operation: functionRequest.operation,
            success: false,
        })) : (() => {
            throw new Error("Invalid function request type.");
        })();
    }))(getAuth(), getFirestore()) : {
        code: "missing-auth",
        message: "No user is signed in.",
        operation: functionRequest.operation,
        success: false,
    };
}));
//# sourceMappingURL=get-firebase-web-authn.js.map